Attribute VB_Name = "Module1"
Public Declare Function GetForegroundWindow Lib "user32" () As Long

Public Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent _
         As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long

Public Declare Function GetClassName Lib "user32" Alias "GetClassNameA" _
         (ByVal hwnd As Long, ByVal lpClassName As String, _
         ByVal nMaxCount As Long) As Long

Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" _
         (ByVal hwnd As Long, ByVal lpString As String, _
         ByVal cch As Long) As Long
         
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
    (ByVal hwnd As Long, _
     ByVal wMsg As Long, _
     ByVal wParam As Long, _
     lParam As Any) As Long

Const WM_GETTEXT = &HD


Const navOpenInNewWindow = &H1
Const navNoHistory = &H2
Const navNoReadFromCache = &H4
Const navNoWriteToCache = &H8
Const navAllowAutosearch = &H10
Const navBrowserBar = &H20
Const navHyperlink = &H40
Const navEnforceRestricted = &H80
Const navNewWindowsManaged = &H100
Const navUntrustedForDownload = &H200
Const navTrustedForActiveX = &H400
Const navOpenInNewTab = &H800
Const navOpenInBackgroundTab = &H1000
Const navKeepWordWheelText = &H2000

Type TChild
    h As Long
    txt As String
    cls As String
End Type

Dim childCount As Integer
Dim ch(1000) As TChild


Sub Main()
    Dim objShell        As Shell
    Dim objShellWindows As ShellWindows
    Dim hForegroundWindow As Long
    Dim sURL As String, sAlternate As String
    Dim addr As String

    hForegroundWindow = GetForegroundWindow
    
    Set objShell = New Shell
    Set objShellWindows = objShell.Windows

    If (Not objShellWindows Is Nothing) Then
        Dim objIE As InternetExplorer
        Set objIE = objShellWindows.Item
        
        'es gibt keine API zum Nummerieren der Tabs
        For i = 0 To objShellWindows.Count - 1
            Set objIE = objShellWindows.Item(i)
            If objIE.hwnd = hForegroundWindow Then
                addr = GetAddressForHWND(objIE.hwnd)
                objIE.Navigate2 addr, navOpenInNewTab
                Exit For
                'sURL = objIE.LocationURL
                'If sURL = addr Then
                '    objIE.Navigate2 sURL, navOpenInNewTab
                'End If
                
            End If
        Next

        Set objIE = Nothing
    End If

    Set objShellWindows = Nothing
    Set objShell = Nothing

End Sub

Private Function GetAddressForHWND(h As Long) As String
Dim res As String
Dim lRet As Long, lParam As Long
Dim lhWnd As Long
Dim i, j As Integer
Dim found As Boolean

    
    GetAddressForHWND = "": res = ""
    

    lhWnd = h
    childCount = 0
    found = False
    lRet = EnumChildWindows(lhWnd, AddressOf EnumChildProc, lParam)
    For i = 0 To childCount - 1
        If ch(i).cls = "Address Band Root" Then
            h = ch(i).h
            found = True
            Exit For
        End If
    Next i
    
    If found Then
        lhWnd = h: childCount = 0
        lRet = EnumChildWindows(lhWnd, AddressOf EnumChildProc, lParam)
        For i = 0 To childCount - 1
            'MsgBox ch(i).cls & vbCrLf & ch(i).txt
            If ch(i).cls = "Edit" Then
                res = GetWindowText2(ch(i).h)
                Exit For
            End If
        Next i
    End If
    
    GetAddressForHWND = res
End Function

Public Function StripNulls(OriginalStr As String) As String
    If (InStr(OriginalStr, Chr(0)) > 0) Then
       OriginalStr = Left(OriginalStr, InStr(OriginalStr, Chr(0)) - 1)
    End If
    StripNulls = OriginalStr
End Function


Private Function EnumChildProc(ByVal lhWnd As Long, ByVal lParam As Long) As Long
    Dim RetVal As Long
    Dim WinClassBuf As String * 255, WinTitleBuf As String * 4096
    Dim WinClass As String, WinTitle As String
    Dim WinWidth As Long, WinHeight As Long

    RetVal = GetClassName(lhWnd, WinClassBuf, 255)
    WinClass = StripNulls(WinClassBuf)
    RetVal = GetWindowText(lhWnd, WinTitleBuf, 4096)
    WinTitle = StripNulls(WinTitleBuf)
    
    ch(childCount).cls = WinClass
    ch(childCount).h = lhWnd
    ch(childCount).txt = WinTitle
    childCount = childCount + 1
    EnumChildProc = True

End Function

Function GetWindowText2(h As Long) As String
Dim buff As String * 4096
Dim res As Long
    res = SendMessage(h, WM_GETTEXT, Len(buff), ByVal buff)
    GetWindowText2 = Left(buff, res)
End Function


